#
# This file is a portion of the Red Hat RHN Registration program
# Copyright (c) 1999, 2000 Red Hat, Inc.  Distributed under GPL
#
# $Id: config.py,v 1.6 2001/08/31 00:03:37 alikins Exp $

import string, os

class Config:
    
    def __init__(self):
	self.dict = {}
	self.fileName = None

    def load(self):
	if self.fileName == None:
	    return
	baseName = string.split(self.fileName, "/")[-1:][0]
	baseName = string.split(baseName, ".")[0]

        if not os.access(self.fileName, os.R_OK):
            print "warning: can't access %s" % self.fileName
            return
        
        f = open(self.fileName, "r")

	key = ""
	comment = ""
	value = ""
	for line in f.readlines():
	    if string.split(line) == []:
		continue
	    if line[0] == "#":
		continue
	    try:
		(key, value) = string.split(line, "=", 2)
	    except:
		continue

	    key = string.lstrip(key)
	    key = string.rstrip(key)
	    value = string.lstrip(value)
	    value = string.rstrip(value)

	    cf = 0
	    pos = string.find(key, "[comment]")
	    if pos != -1:
		key = key[:pos]
		cf = 1

	    if cf:
		comment = value
	    else:
		# possibly split value into a list
		values = string.split(value, ";")
		if len(values) == 1:
		    try:
			value = int(value)
		    except:
			pass
		    self.dict[key] = (comment, value)
		elif values[0] == "":
		    self.dict[key] = (comment, [])
		else:
		    self.dict[key] = (comment, values[:-1])
		comment = ""

	f.close()


    def save(self):
	if self.fileName == None:
	    return
	baseName = string.split(self.fileName, "/")[-1:][0]
	baseName = string.split(baseName, ".")[0]
        
        f = open(self.fileName, "w")
        os.chmod(self.fileName, 0600)

	f.write("# Automatically generated Red Hat RHN Registration config file, do not edit.\n")
	f.write("# Format: 1.0\n")
	f.write("")
	for key in self.dict.keys():
	    val = self.dict[key]
	    f.write("%s[comment]=%s\n" % (key, val[0]))
	    if type(val[1]) == type([]):
		f.write("%s=" % key)
		if len(val[1]) > 0:
		    for l in val[1]:
			f.write("%s;" % l)
		else:
		    f.write(";")
		f.write("\n")
	    else:
		f.write("%s=%s\n" % (key, val[1]))
	    f.write("\n")

	f.close()
	    

    def readEntry(self, name):
	try:
	    val = self.dict[name]
	except:
	    val = (None, None)

	return val[1]


    def writeEntry(self, name, value):
	try:
	    val = self.dict[name]
	except:
	    val = (None, None)

	val = (val[0], value)
	self.dict[name] = val

    def hasEntry(self, name):
        return self.dict.has_key(name)


class RHNConfig(Config) :

    def __init__(self):
	Config.__init__(self)

	self.fileName = "/etc/sysconfig/rhn/rhn_register"
	self.dict['debug'] = ("Whether or not debugging is enabled", 0)
        self.dict['serverURL'] = ("Remote server URL",
                                  "https://www.rhns.redhat.com/XMLRPC")
        self.dict['noSSLServerURL'] = ("Remote server URL without SSL",
                                       "http://www.rhns.redhat.com/XMLRPC")
        self.dict['enableProxy'] = ("Use a HTTP Proxy", 0)
        self.dict['httpProxy'] = ("URL for HTTP proxy", "")
        self.dict['proxyUser'] = ("The username for an authenticated proxy", "")
        self.dict['enableProxyAuth'] = ("To use an authenticated proxy or not", 0)
        self.dict['proxyPassword'] = ("The password for an authenticated proxy", "")
        self.dict['oemInfoFile'] = ("A config file for oemSpecific info", "/etc/sysconfig/rhn/oeminfo")
        
