#!/usr/bin/python


#
# TUI for RHN Registration Configuration
# Copyright (c) 2001 Red Hat, Inc.
#
# Author: Adrian Likins <alikins@redhat.com>
#	  Jay Turner <jkt@redhat.com>
#

#
# Just a quick and simple "text" based config module
# for rhn_register, for those folks who are afraid of text editors
#
import config
from config import *
import sys
import string
import readline



def handleBool(default_value,summary,name):
    valid_input = 0
    if default_value == 0:
        default_string = "No"
    elif default_value == 1:
        default_string = "Yes"
    else:
        default_string = default_value
    default_prompt = "Current value: %s" % default_string
    name_prompt = "Attribute Name: %s" % name
    summary_prompt = "Comment: %s" % summary
    sys.stdout.write('%s\n' % name_prompt)
    sys.stdout.write('%s\n' % summary_prompt)
    sys.stdout.write('%s\n' % default_prompt)

    while not valid_input:
        sys.stdout.write('New Value: ')
        value = raw_input()
        if value == "":
            value = default_value
            valid_input = 1
        elif (string.lower(value) == "yes") or (string.lower(value) == "true") or (value == 1):
            value = 1
            valid_input = 1
        elif (string.lower(value) == "no") or (string.lower(value) == "false") or (value == 0):
            value = 0
            valid_input =1
        else:
            value = None
    return value


def handleList(default_value, summary, name):
    valid_input = 0
    default_string = ""
    if len(default_value) > 0:
        for l in default_value:
            default_string = default_string + "%s;" %  l
    else:
        default_string = "%s" % ""
    default_prompt = "Current value: "
    name_prompt = "Attribute Name: %s" % name
    summary_prompt = "Comment: %s" % summary
    print "%s" % name_prompt 
    print "%s" % summary_prompt
    print "%s" % default_string
    import string
    while not valid_input:
        print "    <return for default, C to clear list, items are ';' seperated>"
        print "New Value:",
        value = raw_input()
        if value == "":
            return_value = string.join(default_value, ';')
            valid_input = 1
        elif value == "C":
            return_value = ""
            valid_input = 1
        else:
            return_value = value
            valid_input = 1

    string_list = string.split(return_value, ';')
    return string_list

def handleString(default_value, summary,name):
    valid_input = 0
    # code to handle lists here
    default_string = default_value
    default_prompt = "Current value: %s" % default_string
    name_prompt = "Attribute Name: %s" % name
    summary_prompt = "Comment: %s" % summary
    sys.stdout.write('%s\n' % name_prompt) 
    sys.stdout.write('%s\n' % summary_prompt)
    sys.stdout.write('%s\n' % default_prompt)
    while not valid_input:
        sys.stdout.write("    <return for default, enter two spaces and return to clear>\n")
        sys.stdout.write('New Value: ')
        value = raw_input()
        if value == "":
            value = default_value
            valid_input = 1
        elif value == ' ':
            value = ""
            value_input = 1
        else:
            valid_input = 1
    return value

item_list = []
def printList(rhn_config):
    global item_list
    count = 0
    item_list = []
    print
    for item in rhn_config.dict.keys():
        summary = "%s" % rhn_config.dict[item][0]
        default_value = rhn_config.dict[item][1]
        name = item
        item_list.append(name)
        count_string = "%s." % count
        # blah, format this correctly
        if default_value == 0:
            default_value = "No"
        if default_value == 1:
            default_value = "Yes"
            
        print "%-3.3s %-18.18s %-57.57s" % (count_string,name, default_value) 
        count = count + 1
    print
    #print item_list

def printShortList(rhn_config,message):
    global item_list
    count = 0
    item_list = []
    short_items = ['httpProxy', 'proxyUser','enableProxyAuth','proxyPassword']
    print message
    for item in rhn_config.dict.keys():
        if item in short_items:
            summary = "%s" % rhn_config.dict[item][0]
            default_value = rhn_config.dict[item][1]
            name = item
            item_list.append(name)
            count_string = "%s." % count
            # blah, format this correctly
            if default_value == 0:
                default_value = "No"
            if default_value == 1:
                default_value = "Yes"

            print "%-3.3s %-18.18s %-57.57s" % (count_string,name, default_value) 
            count = count + 1
    print

def printDetailList(rhn_config):
    global item_list
    count = 0
    for item in rhn_config.dict.keys():
        summary = "%s" % rhn_config.dict[item][0]
        default_value = rhn_config.dict[item][1]
        name = item
        item_list.append(name)
        count_string = "%s." % count
        # blah, format this correctly
        print "%-3.3s %-18.18s%-57.57s" % (count_string,name, summary)
        count = count + 1
    print
       
def main(shortList=None,message=None,cfg=None):
    global item_list
    item_list = []
    rhn_config = cfg
    rhn_config.load()	              
    valid_input = 0
    save_values = 0
    while not valid_input:
        if shortList:
            printShortList(rhn_config,message)
        else:
            printList(rhn_config)
        print
        print
        print "Enter number of item to edit <return to exit, q to quit without saving>: ",
        try:
            value = raw_input()
        except KeyboardInterrupt:
            break
        if (value == ""):
            save_values = 1
            break
        # quit without saving
        if (value == "q"):
            break
        if (value == "h"):
            printDetailList(rhn_config)
        else:
	    try:
                index = string.atoi(value)
                #print "index: %s itemlist[index]: %s " % (index, item_list[index])
                name = item_list[index]
                entry = rhn_config.dict[name]
                summary = "%s" % entry[0]
                default_value = entry[1]
                if (default_value == 0) or (default_value == 1):
                    new_value = handleBool(default_value,summary,name)
                elif type(default_value) == type([]):
                    new_value = handleList(default_value, summary, name)
                else:
                    new_value = handleString(default_value, summary,name)
                rhn_config.writeEntry(name, new_value)
	    except:
		pass
                     
    if save_values:
        save(rhn_config)

def printConfig(rhn_config): 
    for item in rhn_config.dict.keys():
        name = item
        value = rhn_config.dict[item][1]
              
        print "Name: %s" %name
        print "value: %s" % value
       
def save(rhn_config):
    rhn_config.save()


if __name__ == "__main__":
       main()
